diff --git a/migration/block.c b/migration/block.c
index 656f38f..a444058 100644
--- a/migration/block.c
+++ b/migration/block.c
@@ -13,6 +13,7 @@
  * GNU GPL, version 2 or (at your option) any later version.
  */
 
+#include "qemu/osdep.h"
 #include "qemu-common.h"
 #include "block/block.h"
 #include "qemu/error-report.h"
@@ -24,7 +25,6 @@
 #include "migration/migration.h"
 #include "sysemu/blockdev.h"
 #include "sysemu/block-backend.h"
-#include <assert.h>
 
 #define BLOCK_SIZE                       (1 << 20)
 #define BDRV_SECTORS_PER_DIRTY_CHUNK     (BLOCK_SIZE >> BDRV_SECTOR_BITS)
diff --git a/migration/exec.c b/migration/exec.c
index 8406d2b..f1b5e47 100644
--- a/migration/exec.c
+++ b/migration/exec.c
@@ -15,13 +15,13 @@
  * GNU GPL, version 2 or (at your option) any later version.
  */
 
+#include "qemu/osdep.h"
 #include "qemu-common.h"
 #include "qemu/sockets.h"
 #include "qemu/main-loop.h"
 #include "migration/migration.h"
 #include "migration/qemu-file.h"
 #include "block/block.h"
-#include <sys/types.h>
 #include <sys/wait.h>
 
 //#define DEBUG_MIGRATION_EXEC
diff --git a/migration/fd.c b/migration/fd.c
index 3e4bed0..c0afc96 100644
--- a/migration/fd.c
+++ b/migration/fd.c
@@ -13,6 +13,7 @@
  * GNU GPL, version 2 or (at your option) any later version.
  */
 
+#include "qemu/osdep.h"
 #include "qemu-common.h"
 #include "qemu/main-loop.h"
 #include "qemu/sockets.h"
diff --git a/migration/migration.c b/migration/migration.c
index aaca451..2c76998 100644
--- a/migration/migration.c
+++ b/migration/migration.c
@@ -13,6 +13,7 @@
  * GNU GPL, version 2 or (at your option) any later version.
  */
 
+#include "qemu/osdep.h"
 #include "qemu-common.h"
 #include "qemu/error-report.h"
 #include "qemu/main-loop.h"
diff --git a/migration/postcopy-ram.c b/migration/postcopy-ram.c
index 3946aa9..02b28ed 100644
--- a/migration/postcopy-ram.c
+++ b/migration/postcopy-ram.c
@@ -16,9 +16,8 @@
  * source to the destination before all the data has been copied.
  */
 
+#include "qemu/osdep.h"
 #include <glib.h>
-#include <stdio.h>
-#include <unistd.h>
 
 #include "qemu-common.h"
 #include "migration/migration.h"
@@ -57,7 +56,6 @@ struct PostcopyDiscardState {
 #include <sys/mman.h>
 #include <sys/ioctl.h>
 #include <sys/syscall.h>
-#include <sys/types.h>
 #include <asm/types.h> /* for __u64 */
 #endif
 
diff --git a/migration/qemu-file-buf.c b/migration/qemu-file-buf.c
index 49516b8..7b8e78e 100644
--- a/migration/qemu-file-buf.c
+++ b/migration/qemu-file-buf.c
@@ -25,6 +25,7 @@
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE.
  */
+#include "qemu/osdep.h"
 #include "qemu-common.h"
 #include "qemu/error-report.h"
 #include "qemu/iov.h"
diff --git a/migration/qemu-file-stdio.c b/migration/qemu-file-stdio.c
index 9bde9db..f402e8f 100644
--- a/migration/qemu-file-stdio.c
+++ b/migration/qemu-file-stdio.c
@@ -21,6 +21,7 @@
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE.
  */
+#include "qemu/osdep.h"
 #include "qemu-common.h"
 #include "qemu/coroutine.h"
 #include "migration/qemu-file.h"
diff --git a/migration/qemu-file-unix.c b/migration/qemu-file-unix.c
index 6ca53e7..61b059b 100644
--- a/migration/qemu-file-unix.c
+++ b/migration/qemu-file-unix.c
@@ -21,6 +21,7 @@
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE.
  */
+#include "qemu/osdep.h"
 #include "qemu-common.h"
 #include "qemu/error-report.h"
 #include "qemu/iov.h"
diff --git a/migration/qemu-file.c b/migration/qemu-file.c
index 0bbd257..6f4a129 100644
--- a/migration/qemu-file.c
+++ b/migration/qemu-file.c
@@ -21,6 +21,7 @@
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE.
  */
+#include "qemu/osdep.h"
 #include <zlib.h>
 #include "qemu-common.h"
 #include "qemu/error-report.h"
diff --git a/migration/ram.c b/migration/ram.c
index e49749d..40d0533 100644
--- a/migration/ram.c
+++ b/migration/ram.c
@@ -25,7 +25,7 @@
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE.
  */
-#include <stdint.h>
+#include "qemu/osdep.h"
 #include <zlib.h>
 #include "qapi-event.h"
 #include "qemu/bitops.h"
diff --git a/migration/rdma.c b/migration/rdma.c
index dcabb91..86a13b8 100644
--- a/migration/rdma.c
+++ b/migration/rdma.c
@@ -11,6 +11,7 @@
  * later.  See the COPYING file in the top-level directory.
  *
  */
+#include "qemu/osdep.h"
 #include "qemu-common.h"
 #include "migration/migration.h"
 #include "migration/qemu-file.h"
@@ -20,12 +21,9 @@
 #include "qemu/sockets.h"
 #include "qemu/bitmap.h"
 #include "qemu/coroutine.h"
-#include <stdio.h>
-#include <sys/types.h>
 #include <sys/socket.h>
 #include <netdb.h>
 #include <arpa/inet.h>
-#include <string.h>
 #include <rdma/rdma_cma.h>
 #include "trace.h"
 
diff --git a/migration/savevm.c b/migration/savevm.c
index b9caf59..954988d 100644
--- a/migration/savevm.c
+++ b/migration/savevm.c
@@ -26,7 +26,7 @@
  * THE SOFTWARE.
  */
 
-#include "config-host.h"
+#include "qemu/osdep.h"
 #include "qemu-common.h"
 #include "hw/boards.h"
 #include "hw/hw.h"
diff --git a/migration/tcp.c b/migration/tcp.c
index ae89172..ae80e94 100644
--- a/migration/tcp.c
+++ b/migration/tcp.c
@@ -13,7 +13,7 @@
  * GNU GPL, version 2 or (at your option) any later version.
  */
 
-#include <string.h>
+#include "qemu/osdep.h"
 
 #include "qemu-common.h"
 #include "qemu/error-report.h"
diff --git a/migration/unix.c b/migration/unix.c
index b591813..a721c4a 100644
--- a/migration/unix.c
+++ b/migration/unix.c
@@ -13,7 +13,7 @@
  * GNU GPL, version 2 or (at your option) any later version.
  */
 
-#include <string.h>
+#include "qemu/osdep.h"
 
 #include "qemu-common.h"
 #include "qemu/error-report.h"
diff --git a/migration/vmstate.c b/migration/vmstate.c
index a7ad7f2..bf3d5db 100644
--- a/migration/vmstate.c
+++ b/migration/vmstate.c
@@ -1,3 +1,4 @@
+#include "qemu/osdep.h"
 #include "qemu-common.h"
 #include "migration/migration.h"
 #include "migration/qemu-file.h"
diff --git a/migration/xbzrle.c b/migration/xbzrle.c
index 8e220bf..4db3f6c 100644
--- a/migration/xbzrle.c
+++ b/migration/xbzrle.c
@@ -10,6 +10,7 @@
  * See the COPYING file in the top-level directory.
  *
  */
+#include "qemu/osdep.h"
 #include "qemu-common.h"
 #include "include/migration/migration.h"
 